//
// BNPD.H
//
// Battle.net Proxy Server declarations
//
//

#ifndef _BNPROXYD_H_
#define _BNPROXYD_H_

#define  FALSE			0
#define  TRUE			1

// protocol ports used by Battle.net
#define  GAMEPORT               6112
#define  UNIFIEDPORT            6112

#define  PORTOFFSET             20

#define  CONNTYPE_NONE          0x00
#define  CONNTYPE_CLIENT        0x01

#define  CF_DESTROY             0x01

#define  CS_DISCONNECTED        0
#define  CS_CONNECTING          1

#define  SID_SERVERLIST         0x04
#define  SID_STARTADVEX2        0x1A
#define  SID_GAMEDATAADDRESS    0x1B

#define  STAGEBUFSIZE           2048
#define  ADDRLEN                16


typedef struct _CONNSOCKREC {
  int sdSock;
  int nState;
  struct sockaddr_in Addr;
  struct _CONNSOCKREC *pNext;
} CONNSOCKREC, *CONNSOCKRECPTR;

typedef struct _PROXYCONNECTION {
  int nType;
  u_long uFlags;
  int sdClientSock;
  int sdServerSock;
  int nClientBufPos;
  int nClientBufLen;
  int nServerBufPos;
  int nServerBufLen;
  char ClientStageBuf[STAGEBUFSIZE];
  char ServerStageBuf[STAGEBUFSIZE];
  struct _PROXYCONNECTION *pNext;
} PROXYCONNECTION, *PROXYCONNECTIONPTR;

typedef struct {
  unsigned char signature;
  unsigned char msgtype;
  unsigned short bytes;
} MSGHDR, *MSGHDRPTR;

#ifdef WIN32
int __cdecl LogWrite(char *lpszFmt, ...);
#else
int LogWrite(char *lpszFmt, ...);
#endif

#endif
